import 'package:_private_core_network/network_resources/resources.dart';
import 'package:dio/dio.dart';
import 'app_api.dart';
import 'models/auth_industry.dart';

class AuthXRepo {
  AuthXRepo._();

  static AuthXRepo? _instance;

  factory AuthXRepo([MyAppApi? api]) {
    _instance ??= AuthXRepo._();
    _instance!._api = api ?? MyAppApiImp();
    return _instance!;
  }

  late MyAppApi _api;

  Future<NetworkResponse> resetPasswordByEmail(params) async {
    return await _api.resetPasswordByEmail(params);
  }

  Future<ConfirmOtp?> confirmResetProPasswordCode(params) async {
    NetworkResponse response = await _api.confirmResetProPasswordCode(params);
    return response.data;
  }

  Future<bool> updateNewProPasswordByToken(params) async {
    NetworkResponse response = await _api.updateNewProPasswordByToken(params);
    return response.data;
  }

  Future<UpdateInfoResult> checkUpdateEmail(params) async {
    NetworkResponse response = await _api.checkUpdateEmail(params);
    return response.data ?? UpdateInfoResult(status: false);
  }

  Future<ConfirmOtp?> confirmResetUserPasswordCode(params) async {
    NetworkResponse response = await _api.confirmResetUserPasswordCode(params);
    return response.data;
  }

  Future<bool> updateNewUserPasswordByToken(params) async {
    NetworkResponse response = await _api.updateNewUserPasswordByToken(params);
    return response.data;
  }

  Future<String?> setThumbnailForUserOrPro(image, filePath,
      [ProgressCallback? callback]) async {
    NetworkResponse response =
        await _api.setThumbnailForUserOrPro(image, filePath, callback);
    return response.data;
  }

  Future<ProInfo?> getProInfo([params]) async {
    NetworkResponse response = await _api.getProInfo(params);
    return response.data;
  }

  Future<UserModel?> getUserInfo([params]) async {
    NetworkResponse response = await _api.getUserInfo(params);
    return response.data;
  }

  Future<List<AuthIndustry>> getServiceCatForIndustry([params]) async {
    NetworkResponse response = await _api.getServiceCatForIndustry(params);
    return response.data ?? [];
  }

  Future loginTerminal({required params}) async {
    return await _api.loginTerminal(params);
  }

  Future<NetworkResponse> loginUserOrProByUsername(params) async {
    return await _api.loginUserOrProByUsername(params);
  }

  Future<TokenResponseLogin?> refreshToken(String refreshToken) async {
    NetworkResponse response = await _api.refreshToken(refreshToken);
    return response.data;
  }
}
